<template>
  <div >
    <EmployeeForm
      v-bind.sync="employee"
      v-on:submit="submit"
      v-on:cancel="cancel"
    >
    </EmployeeForm>
  </div>
</template>

<script>
import Logger from '@/logger/index';
import EmployeeForm from '@/components/employeeForm/EmployeeForm.vue';
import Leave from '@/models/Leave';
import { mapGetters } from 'vuex';
// import { getAuthenticatedUser } from '@/fb';
import Employee from '@/models/Employee';
import firebase from 'firebase';

export default {
  components: {
    EmployeeForm,
  },
  data() {
    return {
      employee: new Employee(),
    };
  },
  computed: {
    ...mapGetters({
      snackbarText: 'getSnackbarText',
      showSnackbar: 'getShowSnackbar',
    }),
  },
  mounted() {
    console.log('here we intialize subcollection');
    this.employee.addSubCollection(new Leave(), Leave);
  },
  methods: {
    async submit(password) {
      Logger.debug(this.employee);
      const accountDetails = {
        email: this.employee.email,
        password,
        displayName: `${this.employee.firstname} ${this.employee.lastname}`,
        dept: this.employee.department,
      };
      const createNewUserAccount = firebase
        .functions()
        .httpsCallable('createNewUserAccount');

      createNewUserAccount(accountDetails)
        .then((response) => {
          console.log(response.data.user.uid);
          this.employee.uid = response.data.user.uid;
          this.employee.addSubCollection(new Leave(), Leave);
          this.employee.create()
            .then(() => {
              console.log('Done creating Employee doc', this.employee.uid);
              this.$store.dispatch(
                'setSnackbarText',
                'Employee details saved with assigned role!',
              );
              this.$store.dispatch('setShowSnackbar', true);
              this.$router.replace({ name: 'ListEmployee' });
            })
            .catch((error) => {
              this.$store.dispatch('setSnackbarText', error.message);
              this.$store.dispatch('setShowSnackbar', true);
              console.log(error);
            });
        })
        .catch((error) => {
          console.log(error);
        });
    },
    cancel() {
      this.$router.replace({ name: 'ListEmployee' });
    },
  },
};
</script>
